<?php

namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Report\ReportService;

class Tco01001ElaboracaoCardapioRelatorio extends \Zeedhi\Framework\Controller\Report {
    
    protected $reportService; 
    protected $environment; 
    protected $birtStrategy; 
    protected $entityManager; 
    protected $listas; 
    
    public function __construct($reportService, $environment, $birtStrategy, $entityManager, $listas) {
        $this->reportService = $reportService; 
        $this->environment = $environment; 
        $this->birtStrategy = $birtStrategy; 
        $this->entityManager = $entityManager; 
        $this->listas = $listas; 
    }
    
    protected $reportMapping = array ( 
        'TCO01007' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            ),
        'TCO01008' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            ),
        'TCO01009' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            ),
        'TCO01010' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            ),
        'TCO01011' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            ),
        'TCO01012' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            ),
        'TCO01013' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            ),
        'TCO01014' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'   => 'P_DTREFERENCIA',
                        'NRCARDAPIOBASE' => 'P_NRCARDAPIOBASE',
                        'CDARVPRODINI'   => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'   => 'P_CDARVPRODFIN',
                        'CDPRATOINI'     => 'P_CDPRATOINI',
                        'CDPRATOFIN'     => 'P_CDPRATOFIN',
                        'CDREGIAO'       => 'P_CDREGIAO',
                        'NRORG'          => 'P_NRORG'
                    )
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row["__report_name"] = $row["REPORT_NAME"];
        $row["NRORG"] = $this->environment->getNrorgTrab();
        $row["CDREGIAO"] = empty($row["NMREGIAO"]) || $row["NMREGIAO"] == ""? "T": $this->listas->criarListaValores(implode("_", $row["NMREGIAO"]));
        $this->birtStrategy->setReportFormat(strtolower($row['BIRTTYPE']));
    }
    
}