<?php
namespace Teknisa\TCO\Services;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource;
use Teknisa\GER\Services\CrudService;

class TcoEmailService {

    protected $entityManager;
    protected $environment;
    protected $dataSourceManager;
    protected $newCode;
    protected $crudservice;

    public function __construct(EntityManager $entityManager, $environment, DataSource\Manager $dataSourceManager, $newCode, $crudservice)
    {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->dataSourceManager = $dataSourceManager;
        $this->newCode = $newCode;
        $this->crudservice = $crudservice;
    }

    public function iniciaTransacao(){
        $this->entityManager->beginTransaction();
    }

    public function commit(){
        $this->entityManager->commit();
    }

    public function flush(){
        $this->entityManager->flush();
    }

    public function rollback(){
        $this->entityManager->rollback();
    }
    
    public function retornarEmailGerenteELider ($nrdetalheservpropcom, $nrversaopropcom) {
        if(!empty($nrversaopropcom)){
            $sql = "SELECT O.DSEMAILOPER, OL.DSEMAILOPER AS DSEMAILOPERLIDER
                      FROM VERSAOPROPCOM V
                         INNER JOIN PROPOSTACOMERCIAL P ON P.NRPROPOSTACOMERCIAL = V.NRPROPOSTACOMERCIAL
                         INNER JOIN RESPONSAVELPROPCOM R ON R.NRPROPOSTACOMERCIAL = P.NRPROPOSTACOMERCIAL
                         INNER JOIN GERENTENEGOCIO G ON G.NRGERENTENEGOCIO = R.NRGERENTENEGOCIO
                         INNER JOIN OPERADOR O ON O.CDOPERADOR = G.CDOPERADOR
                         LEFT JOIN OPERADOR OL ON OL.CDOPERADOR = G.CDOPERADORLIDER
                     WHERE V.NRVERSAOPROPCOM = :NRVERSAOPROPCOM";
            $stmt = $this->entityManager->getConnection()->prepare($sql);
            $stmt->execute(
                array(
                    "NRVERSAOPROPCOM"   => $nrversaopropcom
                )
            );
        }
        else {
            $sql = "  SELECT O.DSEMAILOPER, OL.DSEMAILOPER AS DSEMAILOPERLIDER
                        FROM DETALHESERVPROPCOM D
                           INNER JOIN SERVICOPROPCOM S ON S.NRSERVICOPROPCOM = D.NRSERVICOPROPCOM
                           INNER JOIN VERSAOPROPCOM V ON V.NRVERSAOPROPCOM = S.NRVERSAOPROPCOM
                           INNER JOIN PROPOSTACOMERCIAL P ON P.NRPROPOSTACOMERCIAL = V.NRPROPOSTACOMERCIAL
                           INNER JOIN RESPONSAVELPROPCOM R ON R.NRPROPOSTACOMERCIAL = P.NRPROPOSTACOMERCIAL
                           INNER JOIN GERENTENEGOCIO G ON G.NRGERENTENEGOCIO = R.NRGERENTENEGOCIO
                           INNER JOIN OPERADOR O ON O.CDOPERADOR = G.CDOPERADOR
                           LEFT JOIN OPERADOR OL ON OL.CDOPERADOR = G.CDOPERADORLIDER
                       WHERE D.NRDETALHESERVPROPCOM = :NRDETALHESERVPROPCOM";
            $stmt = $this->entityManager->getConnection()->prepare($sql);
            $stmt->execute(
                array(
                    "NRDETALHESERVPROPCOM"   => $nrdetalheservpropcom
                )
            );
        }
        return $stmt->fetchAll(\PDO::FETCH_ASSOC);
    }
    
    public function constroiMensagemParaEmail($row, $chaves, $assunto, $motivo, $nrDetalheServPropCom){
        $mensagem = "<html style='padding: 0px; margin: 0px;'>
                       <head>
                          <style>table{border: 1px solid #cccaca; width: 550px; background-color: #dbdbdb;}p, pre, td{font-family: Verdana, Geneva, sans-serif !important; color: #000000; font-size: 14px; line-height: 18px;}.description{padding: 20px; padding-bottom: 10px; padding-top: 4px;}.title{padding: 20px; padding-top: 10px; padding-bottom: 0px;}.title div{font-weight: bold; width: 100%; border-bottom: 1px solid #000;}.footer p{color: #00528C; font-weight: 300; margin-bottom: 40px;}.header .logo{padding-bottom: 10px;}.logo img{width: 200px; margin-left: 20px; margin-top: 15px;}</style>
                          <link rel='stylesheet' href='/zimbra/css/msgview.css?v=120105100505'>
                       </head>
                       <body class='MsgBody MsgBody-html' style='margin: 0px; height: auto;'>
                          <center>
                             <table cellpadding='0' cellspacing='0'>
                                <tbody>
                                   <tr class='header'>
                                      <td class='logo'>
                                         <p><img dfsrc='https://www.teknisa.com/imagens/logo-teknisa.png' src='https://www.teknisa.com/imagens/logo-teknisa.png'></p>
                                      </td>
                                   </tr>
                                   <tr>
                                      <td class='title'>
                                         <div> ".$assunto." </div>
                                      </td>
                                   </tr>
                                ";
        foreach($chaves as $key => $desc ){
            $mensagem .= "<tr> <td class='description'> <b>".$desc."</b>".$row[$key]." </td> </tr>";
        }
        
        if(($motivo == 'EDITAL') or ($motivo == 'CUSTOMIZACAO')){
            $incidencias = $this->getIncidencias($nrDetalheServPropCom);
            $produtos = $this->getProdutos($nrDetalheServPropCom);
            //Adiciona linha de incidências
            $presente = (count($incidencias) > 0) ? "Sim" : "Não";
            $mensagem .= "<tr> <td class='description'> <b>Incidências Solicitadas: </b>" .$presente. " </td> </tr>";
            //Adiciona linha de marcas
            $presente = (count($produtos) > 0) ? "Sim" : "Não";
            $mensagem .= "<tr> <td class='description'> <b>Marcas Solicitadas: </b>" .$presente. " </td> </tr>";
        }
        
        
        $mensagem .= "</tbody> </table> </center> </body> </html>";
        return $mensagem;
    }
    
    public function retornaParametrosNotificacao($nrservico, $nrversaopropcom){
        if(!empty($nrversaopropcom)){
             $sql = "SELECT PC.CDPROPOSTACOMERCIAL,
                              NVL(C.NMRAZSOCCLIE,PS.NMRAZSOCPROS) AS NMRAZSOCIAL,
                              O.NMOPERADOR,
                              V.CDVERSAOPROPCOM,
                              SM.DSSEGMER,
                              R.DSATIVCLI
                            FROM VERSAOPROPCOM V
                            INNER JOIN PROPOSTACOMERCIAL PC
                            ON PC.NRPROPOSTACOMERCIAL = V.NRPROPOSTACOMERCIAL
                            INNER JOIN SEGMERCADO SM
                            ON SM.CDSEGMER = PC.CDSEGMER
                            INNER JOIN ATIVCLIENTE R
                            ON R.CDATIVCLI = PC.CDATIVCLI
                            LEFT JOIN CLIENTE C
                            ON C.CDCLIENTE = PC.CDCLIENTE
                            LEFT JOIN PROSPECT PS
                            ON PS.CDPROSPECT = PC.CDPROSPECT
                            INNER JOIN GERENTENEGOCIO G
                            ON G.NRGERENTENEGOCIO = PC.NRGERENTENEGOCIO
                            INNER JOIN OPERADOR O
                            ON O.CDOPERADOR = G.CDOPERADOR
                            WHERE V.NRVERSAOPROPCOM =:NRVERSAOPROPCOM";
            $stmt = $this->entityManager->getConnection()->prepare($sql);
            $stmt->execute(
                array(
                    "NRVERSAOPROPCOM" => $nrversaopropcom
                )
            );
        }
        else{
            $sql = "SELECT
                        PC.CDPROPOSTACOMERCIAL,
                        NVL(C.NMRAZSOCCLIE,PS.NMRAZSOCPROS) AS NMRAZSOCIAL,
                        O.NMOPERADOR,
                        V.CDVERSAOPROPCOM,
                        SP.NMSERVICOPROPOSTA,
                        SM.DSSEGMER,
                        R.DSATIVCLI,
                        P.NMPADRAOQUALIDADE,
                        T.NMTIPOPUBLICO,
                        H.DSOBSERVACAO
                    FROM
                        DETALHESERVPROPCOM D
                        INNER JOIN SERVICOPROPCOM S ON S.NRSERVICOPROPCOM = D.NRSERVICOPROPCOM
                        INNER JOIN PADRAOQUALIDADE P ON P.NRPADRAOQUALIDADE = S.NRPADRAOQUALIDADE
                        INNER JOIN TIPOPUBLICO T ON T.NRTIPOPUBLICO = S.NRTIPOPUBLICO
                        INNER JOIN SERVICOPROPOSTA SP ON SP.NRSERVICOPROPOSTA = S.NRSERVICOPROPOSTA
                        INNER JOIN (
                            SELECT
                                MAX(DE.NRDETALHESERVPROPCOM) AS NRDETALHESERVPROPCOM,
                                MAX(HI.NRHISTNOTIFPROPCOM) AS NRHISTNOTIFPROPCOM
                            FROM
                                DETALHESERVPROPCOM DE
                                INNER JOIN SERVICOPROPCOM SE ON SE.NRSERVICOPROPCOM = DE.NRSERVICOPROPCOM
                                LEFT JOIN HISTNOTIFPROPCOM HI ON HI.NRSERVICOPROPCOM = SE.NRSERVICOPROPCOM
                            WHERE
                                DE.NRDETALHESERVPROPCOM =:NRDETALHESERVPROPCOM
                        ) MH ON MH.NRDETALHESERVPROPCOM = D.NRDETALHESERVPROPCOM
                        LEFT JOIN HISTNOTIFPROPCOM H ON H.NRHISTNOTIFPROPCOM = MH.NRHISTNOTIFPROPCOM
                        INNER JOIN VERSAOPROPCOM V ON V.NRVERSAOPROPCOM = S.NRVERSAOPROPCOM
                        INNER JOIN PROPOSTACOMERCIAL PC ON PC.NRPROPOSTACOMERCIAL = V.NRPROPOSTACOMERCIAL
                        INNER JOIN SEGMERCADO SM ON SM.CDSEGMER = PC.CDSEGMER
                        INNER JOIN ATIVCLIENTE R ON R.CDATIVCLI = PC.CDATIVCLI
                        LEFT JOIN CLIENTE C ON C.CDCLIENTE = PC.CDCLIENTE
                        LEFT JOIN PROSPECT PS ON PS.CDPROSPECT = PC.CDPROSPECT
                        INNER JOIN GERENTENEGOCIO G ON G.NRGERENTENEGOCIO = PC.NRGERENTENEGOCIO
                        INNER JOIN OPERADOR O ON O.CDOPERADOR = G.CDOPERADOR
                    WHERE
                        D.NRDETALHESERVPROPCOM =:NRDETALHESERVPROPCOM";
            $stmt = $this->entityManager->getConnection()->prepare($sql);
            $stmt->execute(
                array(
                    "NRDETALHESERVPROPCOM" => $nrservico
                )
            );
        }
        return $stmt->fetch(\PDO::FETCH_ASSOC);
    }
    
    /**
     * Retorna informações de incidências
     * 
     * @param int|float $nrServicoPropCom
     * 
     * @return servico da proposta
     */
     
    public function getIncidencias($nrDetalheServPropCom){
        $conditions = array(
            array(
                "columnName" => "NRDETALHESERVPROPCOM", 
                "operator"   => "=",
                "value"      => $nrDetalheServPropCom
            ),
            array(
                "columnName" => "NRINCIDENCIAPROPCOM", 
                "operator"   => "IS_NOT_NULL",
                "value" => ""
            )
        );

        $dataset = $this->crudservice->getFilteredDataSet("tco01100_detalhe_incidencias", $conditions)->getRows();
        
        return $dataset;
    }
    
    /**
     * Retorna informações de produtos
     * 
     * @param int|float $nrServicoPropCom
     * 
     * @return servico da proposta
     */
     
    public function getProdutos($nrDetalheServPropCom){
        $conditions = array(
            array(
                "columnName" => "NRDETALHESERVPROPCOM", 
                "operator"   => "=",
                "value"      => $nrDetalheServPropCom
            ),
            array(
                "columnName" => "NRDETSERVPROPCOMPLAN", 
                "operator"   => "=",
                "value"      => $nrDetalheServPropCom
            ),
            array(
                "columnName" => "NRPRODUTOPROPCOM", 
                "operator"   => "IS_NOT_NULL",
                "value" => ""
            )
        );

        $dataset = $this->crudservice->getFilteredDataSet("tco01200_produtos", $conditions)->getRows();
        
        return $dataset;
    }
    
    public function retornaEmailOperPlanejamento(){
        $sql = "SELECT OPERADOR.DSEMAILOPER
                  FROM PARAMTCO PT
                       CROSS JOIN PERFACESSPARC
                       JOIN OPERADOR ON ( PERFACESSPARC.NRPARCNEGOCIO   = OPERADOR.NRPARCNEGOCIO
                                     AND PERFACESSPARC.NRORG = OPERADOR.NRORG )
                 WHERE PERFACESSPARC.NRPERFILACESSO = PT.NRPERFILACESSO";
        $stmt = $this->entityManager->getConnection()->prepare($sql);
        $stmt->execute();
        return $stmt->fetchAll(\PDO::FETCH_ASSOC);
    }
    
    
}